#ifndef _qlbar_h_
#define _qlbar_h_

#include <X11/Xlib.h>
#include <stdlib.h>
#include <pthread.h>

#include "constants.h"
#include "qlitem.h"
#include "qlconf.h"

#include <vector>

void* hideBar(void * thid);

class QLBar {
	
	private:
		Display *display;
		Visual *visual;
		Window window, root;
		Colormap colormap;
		GC gc;
		int m_defScreen;

		XGCValues gv;
		
		QLConf *m_pcfg;
		vector <QLItem *> items;

		int m_icon_width;
		int m_icon_height;
		// position of qlbar
		int m_bar_x; 
		int m_bar_y;

		int m_icon_start_x;
		int m_icon_start_y;


		int m_bar_width;
		int m_bar_height;
		int m_dock;
		int m_bar_time;
		int m_bar_color;


//		Imlib_Image image; // main image
//		QLItem* active;
		pthread_t hidding_thread ;
		pthread_mutex_t graph_mutex;


		void prepareItems();
		int getBarWidth() const;
		int getBarHeight() const;

		QLItem * findItem (const Window window) const;
		bool active;

		void ComputeXY(int &x, int &y, int &ic_x, int &ic_y) ;

	public:
		QLBar ();
		~QLBar ();

		int Prepare ();
		int Run ();

		int AddItem (QLItem * pItem);
		int AddItem (const int & index, QLItem * pItem);

		void SetConfig (QLConf *cfg);

		int GetBarX() const;
		bool GetActive() const;
		
		void hideAllItems() ;
		void showAllItems() ;
		void ScaleItems();

		//attribute setters
		void SetDock(const int &pos);
		void SetBarTime(const int &milisec);
		int GetBarTime () const;
		void SetIconDimension(const int &icon_width, const int &icon_height, const bool &redraw);
		void SetBarColor(const int &color);
		void SetBarDimension(const int &bar_width, const int &bar_height, const bool &redraw);

};

#endif
