#ifndef _qlconf_h_
#define _qlconf_h_

#include <vector>

#include "qlitem.h"

using namespace std;


class QLConf {
	private:
		int icon_width;
		bool b_icon_width;

		int icon_height;
		bool b_icon_height;

		// bar height, default 1 pixel
		int bar_height;
		bool b_bar_height;

		// width of a bar, if set to -1
		// bar_width = icons count * icon_width
		int bar_width;
		bool b_bar_width;

		// color of bar
		int bar_color;
		bool b_bar_color;

		// coolbar position, north, south, etc..
		int position;
		bool b_position;

		// horizontal or vertical layout
		int layout;	
		bool b_layout;

		// delay time after that coolbar will hide [ms]
		int bar_time;
		bool b_bar_time;

		int hoffset;
		bool b_hoffset;

		int voffset;
		bool b_voffset;

		vector <QLItem *> items;

	protected:
		int comp (const char *, const char *) const;
		void Set(int *dst, const int &src, bool *state, const bool ov);

	public:
		QLConf();
		~QLConf();

		int Parse( const char * , const char *, const bool override = false);

		int ReadMenuConfig( const char * filename);
		int ReadConfigFile( const char * filename);
	
		void Error(const char * msg, const bool verbose = true) const;
		bool Validate(const bool verbose) const;

		// getters
		int GetIconWidth() const { return icon_width; }
		int GetIconHeight() const { return icon_height; }
		int GetBarWidth(bool asis = false) const;
		int GetBarHeight(bool asis = false) const;
		int GetBarColor() const { return bar_color; }
		int GetPosition () const { return position; }
		int GetLayout () const { return layout; }
		int GetBarTime() const { return bar_time; };
		int GetVOffset() const { return voffset; };
		int GetHOffset() const { return hoffset; };

		vector<QLItem*> * GetItems() { return &items; }

};


#endif
