#ifndef _qlitem_h_
#define _qlitem_h_

#include <X11/Xlib.h>
#include <Imlib2.h>


using namespace std;

class QLItem {

	private:
		char * m_pIconPath;
		char * m_pExecPath;
		char * m_pName;

		Imlib_Image im;
		Pixmap pix;
		Pixmap mask;

		int m_width;
		int m_height;
		int m_x;
		int m_y;
	
		Window m_window;
		Display *m_display;
	
		bool failed;
	
		void createDefIconPath(char *&);

	public:
		QLItem ( char * ip, char * ep, char * fn);
		~QLItem ();

		void Init();
		bool CreateUI (Display * display, Window window, const int &x, const int &y, const int & w, const int &h);
		bool isFailed() const { return failed; }

		void Paint();
		void Show ();
		void Hide ();
		void Scale (const int & w, const int & h);
		Window GetWindow() const;
		
		void Execute ();

};

#endif
